package com.sun.beans.editors;

import java.beans.PropertyEditorSupport;

public class StringEditor extends PropertyEditorSupport
{
    public StringEditor() {
    }
    
    @Override
    public String getJavaInitializationString() {
        Object value = this.getValue();
        if (value == null) {
            return "null";
        }
        String string = value.toString();
        int length = string.length();
        StringBuilder sb = new StringBuilder(length + 2);
        sb.append('\"');
        for (int i = 0; i < length; ++i) {
            int char1 = string.charAt(i);
            switch (char1) {
                case 8: {
                    sb.append("\\b");
                    break;
                }
                case 9: {
                    sb.append("\\t");
                    break;
                }
                case 10: {
                    sb.append("\\n");
                    break;
                }
                case 12: {
                    sb.append("\\f");
                    break;
                }
                case 13: {
                    sb.append("\\r");
                    break;
                }
                case 34: {
                    sb.append("\\\"");
                    break;
                }
                case 92: {
                    sb.append("\\\\");
                    break;
                }
                default: {
                    if (char1 < ' ' || char1 > '~') {
                        sb.append("\\u");
                        String hexString = Integer.toHexString(char1);
                        for (int j = hexString.length(); j < 4; ++j) {
                            sb.append('0');
                        }
                        sb.append(hexString);
                        break;
                    }
                    sb.append((char)char1);
                    break;
                }
            }
        }
        sb.append('\"');
        return sb.toString();
    }
    
    @Override
    public void setAsText(String value) {
        this.setValue(value);
    }
}
